using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using zeeAniContentProcessor.Properties;

// TODO: replace this with the type you want to import.
using TImport = zeeAniContentProcessor.DataContainer;

namespace zeeAniContentProcessor
{
    /// <summary>
    /// This class will be instantiated by the XNA Framework Content Pipeline
    /// to import a file from disk into the specified type, TImport.
    /// 
    /// This should be part of a Content Pipeline Extension Library project.
    /// 
    /// TODO: change the ContentImporter attribute to specify the correct file
    /// extension, display name, and default processor for this importer.
    /// </summary>
    [ContentImporter(".xml", DisplayName = "zeeAni Importer - Createdbyx.com", DefaultProcessor = "zeeAniContentProcessor")]
    public class zeeAniContentImporter : ContentImporter<TImport>
    {
        public override TImport Import(string filename, ContentImporterContext context)
        {
            // declare a varible for storing the data contained in the file
            string data = string.Empty;

            // report that asset processing has begun
            context.Logger.PushFile(filename);

            // try to read the file
            try
            {
                // read all file data as a string
                data = System.IO.File.ReadAllText(filename);
            }
            catch (Exception ex)
            {
                // throw a InvalidContentException exception that reports the problem
                throw new InvalidContentException(Resources.CouldNotReadFile,
                                  new ContentIdentity(System.IO.Path.GetFullPath(filename)), ex);
            }
            finally
            {
                // report that asset processing has completed
                context.Logger.PopFile();
            }

            // return the string data that was read as a DataContainer object.
            return new DataContainer(data);
        }
    }
}
