using System;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using System.IO;
using System.Collections.Generic;
using zeeAniContentReader.Properties;

// TODO: replace this with the type you want to read.
using TRead = zeeAni.AnimationSet<string, zeeAni.SpriteFrame>;

namespace zeeAniContentReader
{
    /// <summary>
    /// This class will be instantiated by the XNA Content Pipeline
    /// to read the specified data type from binary .xnb format.
    /// 
    /// Unlike the other Content Pipeline support classes, this should
    /// be a part of your main game project, and not the Content Pipeline
    /// Extension Library project.
    /// </summary>
    public class zeeAniContentReader : ContentTypeReader<TRead>
    {
        protected override TRead Read(ContentReader input, TRead existingInstance)
        {
            // calc the number of characters that will be read
            int count = (int)(input.BaseStream.Length - input.BaseStream.Position);

            // create a string reader to store the data that will be read
            StringBuilder sb = new StringBuilder(count, count);

            // read "count" number of characters from the input object and append the data
            // to the StringBuilder varible
            sb.Append(input.ReadChars(count));

            // create a loader object
            zeeAni.AnimationLoader<string, zeeAni.SpriteFrame> loader;
            loader = new zeeAni.AnimationLoader<string, zeeAni.SpriteFrame>(input.ContentManager, zeeAni.Converters.ConvertString);
          
            // load the raw xml animation data as a string
            if (loader.LoadXml(sb.ToString()))
            {
                // everything loaded ok
            }
            else
            {
                // throw a InvalidContentException exception reporting the error
                throw new Exception(Resources.BadFileData + "\r\n" + loader.ErrorMessage);
            }

            sb = null;

            // return the reference the Doc varible
            return loader.Animation;
        }
    }
}
